// Ein kleines Applet zum Thema: Berechnen von Gezeiten
// geschrieben 10.08.2000 von Klaus Rotter
// Copyright (C) 2000 by Klaus Rotter (klaus@rotters.de)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License 2 as published by
// the Free Software Foundation

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// History:
// 2000-08-10: Initial Version
// 2003-02-03: Adapted for Sharp-Zaurus 
// 2004-05-30: Removed some Bugs: Zaurus' JRE is a 1.1 machine

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.text.*;
import java.io.*;

public class Gezeiten extends Applet
{
    int aktort;
    int aktland;
    boolean minima;

    Choice landfeld, ortfeld;
    TextField datumsfeld, zeitfeld;
    Font font;

    Berechnung gzb = new Berechnung();

    public void init()
    {
        // Font initialisieren

        font = new Font("Helvetica",Font.PLAIN,11);
        setFont(font);

        setLayout(null);

        setBackground (Color.lightGray);

        // Buttons und Labels zeichnen

        Label landl = new Label("Land:");
        add(landl);
        landl.setBounds (2,20,32,10);

        landfeld = new Choice();
        add(landfeld);
        landfeld.setBounds (35,16,155,18);
        landfeld.addItemListener (new ItemListener() {
            public void itemStateChanged (ItemEvent evt) {
                setaktland(landfeld.getSelectedIndex()+1);
                repaint();
            }
        });
        // font = new Font("Helvetica",Font.PLAIN,11);
        landfeld.setFont(font);

        Label ortl = new Label("Ort:");
        add (ortl);
        ortl.setBounds (2,41,32,10);

        ortfeld = new Choice();
        add (ortfeld);
        ortfeld.setBounds (35,37,155,18);
        ortfeld.addItemListener (new ItemListener() {
            public void itemStateChanged (ItemEvent evt) {
                ItemSelectable s = evt.getItemSelectable();
                Object[] selected = s.getSelectedObjects();
                if (selected != null)
                    aktort = gzb.getOrtIndex((String) selected[0]);
                gzb.init(aktort);
                repaint();
            }
        });

        Label datuml = new Label("Datum:");
        add (datuml);
        datuml.setBounds (2,66,32,10);
        Date myDate = new Date();
        String dateStr = DateFormat.getDateInstance().format(myDate);
        datumsfeld = new TextField(dateStr);
        add (datumsfeld);
    	datumsfeld.setBounds (35, 62,60,18);
        datumsfeld.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                repaint();
            }
        });

        Label zeitl = new Label("Uhrzeit:");
        add (zeitl);
        zeitl.setBounds (95,62,40,10);

        String timeStr = DateFormat.getTimeInstance().format(myDate);
        zeitfeld = new TextField(timeStr);
        add (zeitfeld);
    	zeitfeld.setBounds (135, 58,50,20);
        zeitfeld.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                repaint();
            }
        });

        // Button berechne = new Button("Tafel");
        // add (berechne);
    	// berechne.setBounds ( 130, 81, 50, 20);
        //berechne.addActionListener(new ActionListener() {
        //    public void actionPerformed( ActionEvent e) {
        //        Date d = new Date();
        //        d = gzb.parseDate(datumsfeld.getText());

        //        Gezeitentafel gt = new Gezeitentafel(d,aktort);
        //    }
        //});

        Button grafik = new Button("Grafik");
        add (grafik);
    	grafik.setBounds (195, 16, 40, 20);
        grafik.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                Date d = new Date();
                d = gzb.parseDate(datumsfeld.getText());

                Plot p = new Plot(aktort,d,0,0,240,300);
            }
        });

        Button jgrafik = new Button("Jahr");
        add (jgrafik);
    	jgrafik.setBounds (195, 37, 40, 20);
        jgrafik.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                JahresPlot p = new JahresPlot(aktort,2003,0,0,240,300);
            }
        });

        Button info = new Button("Info");
        add (info);
    	info.setBounds (195, 58, 40, 20);
        info.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                OrtsInfo o = new OrtsInfo(aktort);
            }
        });

        for (int i=1; i < gzb.getMaxLand(); i++) {
            // System.out.println("i="+String.valueOf(i)+" land:"+gzb.getLand(i));
            landfeld.add (gzb.getLand(i));
        }
        setaktland(8);
        landfeld.select(7);
        aktort = 10;        // Bsum
        gzb.init(aktort);
        repaint();	
    } // end of init()

    public void setaktland (int pos)
    {
        int i, a=2^30;

        ortfeld.removeAll();

        for (i=0; i < gzb.getMaxOrt(); i++) {
            if (gzb.getLandIdxOrt(i) == pos) {
                ortfeld.add(gzb.getOrt(i));
            }
        }
        aktort = gzb.getOrtIndex(ortfeld.getSelectedItem());
        gzb.init(aktort);
    }

    // text3d (String str, x, y, size)
    // Gibt Text str schattiert an Position x,y mit Grsse size aus

    public void text3d(String txt, int x, int y, int size)
    {
        Font old, fnt = new Font("Helvetica",Font.PLAIN, size);

        Graphics g = getGraphics();
        old = g.getFont();
        g.setFont(fnt);

        //g.setColor(Color.white);
        //g.drawString(txt,x+1,y+1);
        g.setColor(Color.black);
        g.drawString(txt,x,y);
        g.setFont(old);
    }

    public void drawCenterString(String txt, int y, int size, Color color)
    {
        Font old, fnt = new Font("Helvetica",Font.PLAIN, size);

        Graphics g = getGraphics();
        old = g.getFont();
        g.setFont(fnt);
        
        Color oldcol = g.getColor();
        g.setColor(color);

        int w = g.getFontMetrics().stringWidth(txt);
        g.drawString(txt, (getSize().width-w)/2,y);
        g.setFont(old);
        g.setColor(oldcol);
    }


    public static String d2s (double d)
    {
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        nf.setMinimumFractionDigits(2);
        
        String s = nf.format(d);

        return s;
    }

    public int berechne ()
    {
        int i, j;
        int tag, mon, jahr;
        final int oip = 92;
        final int gip = 145;

        Date akt, z;
        DateFormat df = DateFormat.getDateInstance();
        DateFormat tf = DateFormat.getTimeInstance();

        double start_d, akt_d, h;

        Graphics g = getGraphics();

        g.clearRect(10,160,520,400);

        g.setColor(Color.black);
        g.draw3DRect(2, oip +2, 230, 35,false);
        g.drawString("Ortsinfo", 5, oip);
        g.drawString("Position:",7, oip + 12);
        g.drawString("Ortszeit:",120, oip + 12);

        g.setColor(Color.blue);
        g.drawString(gzb.getOrt(aktort)+" ("+gzb.getLand(gzb.getLandIdxOrt(aktort))+")",50, oip);

        String pos = String.valueOf(gzb.gzp.hmin[aktort])+"."+String.valueOf(gzb.gzp.hsek[aktort])+gzb.gzp.hb[aktort]+" "+String.valueOf(gzb.gzp.vmin[aktort])+"."+String.valueOf(gzb.gzp.vsek[aktort])+gzb.gzp.vl[aktort];
        g.drawString(pos,52, oip + 12);

        if (gzb.gzp.zv[aktort] > 0) 
            g.drawString(String.valueOf(gzb.gzp.zv[aktort])+" (GMT)",165, oip + 12);
        else
            g.drawString(String.valueOf(gzb.gzp.zv[aktort])+" (GMT)",165, oip + 12);
       
        double r = (gzb.gzp.amp[aktort][2] + gzb.gzp.amp[aktort][3])/(gzb.gzp.amp[aktort][6]+gzb.gzp.amp[aktort][5]);

        if (r < 0.25) {
            g.drawString("Halbtgige Gezeitenform mit jeweils etwa",7, oip + 22);
            g.drawString("gleichen Wasserstnden",7, oip + 33);
        }
        else if (r >= 0.25 && r <1.5) {
            g.drawString("Halbtgige Gezeitenform mit unterschiedlichen",7, oip + 22);
            g.drawString("Wasserstnden",7,oip + 33);
        }
        else if (r >= 1.5 && r < 3.0) {
            g.drawString("Gemischte Gezeitenform mit ein oder zwei",7,oip + 22);
            g.drawString("Gezeiten pro Tag",7,oip + 33);
        }
        else {
            g.drawString("Tgliche Gezeitenform mit einer Gezeit",10,oip + 22);
            g.drawString("pro Tag",10,oip + 33);
        }

        g.setColor(Color.black);
        g.draw3DRect(2, gip +2 ,230,70,false);
        g.drawString("Gezeiteninfo am",5, gip);

        // ref = gzb.getDate(1,1,1980);     // Zeit in Sekunden seit EPOC (=1.1.1970)
        akt = gzb.parseDate(datumsfeld.getText());

        start_d = gzb.getDezTime(akt);   // Dezimalzeit in Tagen seit dem 1.1.1980
        akt_d = start_d;

        String nez;

        if (gzb.gzp.zv[aktort] > 0)
            nez = new String("GMT +"+String.valueOf(gzb.gzp.zv[aktort]));
        else
            nez = new String("GMT "+String.valueOf(gzb.gzp.zv[aktort]));

        // g.drawString("Gezeiten: Minimal: "+d2s(gzb.minimal)+"m, Mittelwert: "+d2s(gzb.z0/100)+"m, Maximal: "+d2s(gzb.maximal)+"m"+" -> max. theo. Tidenhub: "+d2s(gzb.hub)+"m",10,170);
        g.drawString("Hhe der Gezeit um "+tf.format(akt)+" Uhr ("+nez+"): "+d2s(gzb.hoehe(akt_d))+"m", 7 , gip + 16);
        //g.drawString("Hhe der Gezeit: "+d2s(gzb.hoehe(akt_d))+"m",5,205);
	
        if (false) {
            g.setColor(Color.blue);
            text3d("Wasserstand fr "+gzb.getOrt(aktort)+" am "+df.format(akt),90,230,15);

            text3d("Stunde:",10,240,12);
            text3d("Hhe/m:",10,260,12);
            text3d("Stunde:",10,285,12);
            text3d("Hhe/m:",10,305,12);

            for (j=0; j<2; j++)
            {
                for (i=0; i<12; i++)
                {
                    h = gzb.hoehe (akt_d);
                    g.drawString(gzb.getStringTime(akt_d),80+35*i,240+45*j);
                    g.drawString(d2s(h),80+35*i,260+45*j);
                    akt_d += 1.0/24.0;
                }
            }
        }

        double h0, h1, h2, h3, h4, h5;
        double z0, z1, z2, z3, z4, z5;
        double dz, ext, lastext=0;
        int mt, omt=0;

        z0 = -2.0/24.0;
        z1 = -1.5/24.0;

        h0 = gzb.hoehe (start_d - z0);
        h1 = gzb.hoehe (start_d - z1);

        i = 0;

        g.setColor(Color.black);

        for (dz = -1.0; dz <= 26.0; dz += 0.5)
        {
            z2 = dz;
            h2 = gzb.hoehe (start_d + z2/24.0);
            ext = extr (z0, h0, z1, h1, z2, h2);
            if ((ext > z0) && (ext < z2))
            {
                z3 = ext - (5.0/60.0);
                h3 = gzb.hoehe (start_d + z3/24.0);
                z4 = ext;
                h4 = gzb.hoehe (start_d + z4/24.0);
                z5 = ext + (5.0/60.0);
                h5 = gzb.hoehe (start_d + z5/24.0);
                ext = extr (z3, h3, z4, h4, z5, h5);

                mt = gzb.getIntTime(ext);

                if ((ext > z0) && (ext < z2) && (ext >= 0.0) && (ext < 24.0) && (mt != omt)) {
                    if (minima)
                        g.drawString("Niedrigwasser: "+gzb.getStringTime(start_d+ext/24.0)+" Uhr  Hhe: "+d2s(gzb.hoehe(start_d+ext/24.0))+"m", 7, gip+27 +12*i++);
                    else
                        g.drawString("Hochwasser:    "+gzb.getStringTime(start_d+ext/24.0)+" Uhr  Hhe: "+d2s(gzb.hoehe(start_d+ext/24.0))+"m", 7, gip+27 +12*i++);
                    omt = mt;
                }
            }
            z0 = z1;
            z1 = z2;
            h0 = h1;
            h1 = h2;
        }
        return(0);
    }

    public double extr (double x1, double y1, double x2, double y2, double x3, double y3)
    {
        double h1, h2, ax, bx;

        h1 = x3*x3 + x1*x2 + - x1*x3 - x2*x3;
        h2 = x2-x1;

        if ((h1 != 0.0) && (h2 != 0.0)) {
            ax = (y3-y1 + (x1-x3)*(y2-y1)/h2)/h1;
            bx = (y2-y1-ax * (x2*x2 - x1*x1))/h2;
            if (ax != 0) {
                if (ax > 0)
                    minima = true;
                else
                    minima = false;
                return (-bx/(2*ax));
            }
            else
                return -1000;
        }
        else
            return -1000;
    }

    public void paint(Graphics g)
    {
        //drawCenterString("Gezeitenberechnung",15,15,Color.black);
        //drawCenterString("(c) 2000-04 by Klaus Rotter (kr@rotters.de)",25,9,Color.black);
        drawCenterString("Daten nicht zur Schiffsnavigation verwendbar!",10,10,Color.red);

        Font fnt = new Font("SansSerif",Font.PLAIN,12);
        g.setFont(fnt);
        berechne();
    }
    // end of paint
}
// end of class

class Message extends Dialog
{
    public Message(Frame f, String text)
    {
        super(f, "Eingabe", true);
        setLayout(null);
        Font font = new Font("SansSerif",Font.PLAIN,12);
        setFont(font);

        setBounds (200,100,280,130);

        Label dl = new Label(text);
        add (dl);
        dl.setBounds (10,30,280,20);

        Button ok = new Button("OK");
        add (ok);
    	ok.setBounds (200,60,60,30);
        ok.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                dispose();
            }
        });
        show();
    }
}

class Requester extends Dialog
{
    StringBuffer sb;	
    TextField textf;

    public Requester(Frame f, String text, StringBuffer eingabe)
    {
        super(f, "Eingabe", true);
        setLayout(null);
        Font font = new Font("SansSerif",Font.PLAIN,12);
        setFont(font);

	sb = eingabe;

        setBounds (200,100,280,130);

        Label dl = new Label(text);
        add (dl);
        dl.setBounds (10,30,280,20);

        textf = new TextField(eingabe.toString());
        add (textf);
    	textf.setBounds (10, 60,180,30);
        textf.addActionListener(new ActionListener() {
	    public void actionPerformed( ActionEvent e) {
	    	sb.setLength(0);
	    	sb.append(textf.getText());
    	    }
        });

        Button ok = new Button("OK");
        add (ok);
    	ok.setBounds (200, 60,60,30);
        ok.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
		sb.setLength(0);
		sb.append(textf.getText());
                dispose();
            }
        });
        show();
    }
}

class OrtsInfo extends Frame
{
    int aktort;

    Berechnung gzb = new Berechnung();

    public OrtsInfo(int ort)
    {
        setLayout(null);
        Font font = new Font("SansSerif",Font.PLAIN,12);
        setFont(font);
        setBackground (Color.lightGray);

        aktort = ort;
        // jahr = j;
        // gzb.init(aktort);
	    // plot = this;

        setTitle("Ortsinformationen fr "+gzb.getOrt(aktort));

        setBounds (100,100,450,300);

        Button ende = new Button("Ende");
        add (ende);
        ende.setBounds (300,240,80,30);
        ende.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                dispose();
            }
        });
        show();
    }

    public void paint(Graphics g)
    {
        g.drawString("Ort: "+gzb.getOrt(aktort)+" in "+gzb.getLand(gzb.getLandIdxOrt(aktort)),10,60);

        String pos = String.valueOf(gzb.gzp.hmin[aktort])+"."+String.valueOf(gzb.gzp.hsek[aktort])+gzb.gzp.hb[aktort]+" "+String.valueOf(gzb.gzp.vmin[aktort])+"."+String.valueOf(gzb.gzp.vsek[aktort])+gzb.gzp.vl[aktort];

        if (gzb.gzp.zv[aktort] > 0)
            g.drawString("Position: "+pos+ "  Ortszeit: +"+String.valueOf(gzb.gzp.zv[aktort])+" (GMT)",10,80);
        else
            g.drawString("Position: "+pos+ "  Ortszeit: "+String.valueOf(gzb.gzp.zv[aktort])+" (GMT)",10,80);

        g.drawString("Gezeitenparameter: Z0 = "+ String.valueOf(gzb.gzp.z0[aktort]) +" cm",10,100);

        String nam[] = {"Sa","Q1","O1","K1","N2","M2","S2","MN4","M4","MS4"};

        g.drawString("Amp/mm:",10,140);

        for (int i=0; i<10; i++) {
            g.drawString(nam[i],80+35*i,120);
            g.drawString(String.valueOf((int) gzb.gzp.amp[aktort][i]),80+35*i,140);
        }

        double r = (gzb.gzp.amp[aktort][2] + gzb.gzp.amp[aktort][3])/(gzb.gzp.amp[aktort][6]+gzb.gzp.amp[aktort][5]);

        if (r < 0.25)
            g.drawString("Halbtgige Gezeitenform mit jeweils etwa gleichen Wasserstnden",10,170);
        else if (r >= 0.25 && r <1.5)
            g.drawString("Halbtgige Gezeitenform mit unterschiedlichen Wasserstnden",10,170);
        else if (r >= 1.5 && r < 3.0)
            g.drawString("Gemischte Gezeitenform mit ein oder zwei Gezeiten pro Tag",10,170);
        else
            g.drawString("Tgliche Gezeitenform mit einer Gezeit pro Tag",10,170);

    }
}

class Gezeitentafel extends Frame
{
    int aktort, mon, year=2000;
    Date akt;
    boolean minima;

    Berechnung gzb = new Berechnung();

    public Gezeitentafel(Date d, int ort)
    {
        Calendar c = Calendar.getInstance();
        c.setTime(d);
        akt = d;
        mon = c.get(Calendar.MONTH)+1;
        year = c.get(Calendar.YEAR);

        gzb.init(ort);

        setLayout(null);
        Font font = new Font("SansSerif",Font.PLAIN,12);
        setFont(font);
        setBackground (Color.lightGray);

        aktort = ort;

        setTitle("Gezeitenkalender fr "+gzb.getOrt(aktort));

        setBounds (0,0,300,240);

        Button ende = new Button("Ende");
        add (ende);
        ende.setBounds (0,20,60,20);
        ende.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                dispose();
            }
        });
        show();
    }

    public void paint(Graphics g)
    {
        String monname = "Januar";
        int tage=31;

        double start_d = gzb.getDezTime(gzb.getDate(1,mon,year));   // Dezimalzeit in Tagen seit dem 1.1.1980

        switch (mon)
        {
            case  1: monname = "Januar"; break;
            case  2: monname = "Februar"; break;
            case  3: monname = "Mrz"; break;
            case  4: monname = "April"; break;
            case  5: monname = "Mai"; break;
            case  6: monname = "Juni"; break;
            case  7: monname = "Juli"; break;
            case  8: monname = "August"; break;
            case  9: monname = "September"; break;
            case 10: monname = "Oktober"; break;
            case 11: monname = "November"; break;
            case 12: monname = "Dezember"; break;
        }

        g.drawString("Ort: "+gzb.getOrt(aktort)+" in "+gzb.getLand(gzb.getLandIdxOrt(aktort))+" im Monat "+monname+" 2000",10,60);

        g.setColor(Color.red);
        g.drawString("Die hier berechneten Daten drfen nicht fr am Meer verwendet werden",10,75);
        g.setColor(Color.black);

        g.drawString("        Hochwasser                      Niedrigwasser",50,90);
        g.drawString("vormittags    nachmittags        vormittags    nachmittags",50,105);
        g.drawString("Zeit/Hhe     Zeit/Hhe          Zeit/Hhe     Zeit/Hhe",50,120);

        for (int j=1; j<=tage; j++)
        {
            double h0, h1, h2, h3, h4, h5;
            double z0, z1, z2, z3, z4, z5;
            double dz, ext, lastext=0;
            int mt, omt=0;

            z0 = -2.0/24.0;
            z1 = -1.5/24.0;

            // System.out.println("start_d="+String.valueOf(start_d));

            h0 = gzb.hoehe (start_d - z0);
            h1 = gzb.hoehe (start_d - z1);

            g.setColor(Color.black);

            for (dz = -1.0; dz <= 26.0; dz += 0.5)
            {
                z2 = dz;
                h2 = gzb.hoehe (start_d + z2/24.0);
                ext = gzb.extr (z0, h0, z1, h1, z2, h2);
                if ((ext > z0) && (ext < z2))
                {
                    z3 = ext - (5.0/60.0);
                    h3 = gzb.hoehe (start_d + z3/24.0);
                    z4 = ext;
                    h4 = gzb.hoehe (start_d + z4/24.0);
                    z5 = ext + (5.0/60.0);
                    h5 = gzb.hoehe (start_d + z5/24.0);
                    ext = gzb.extr (z3, h3, z4, h4, z5, h5);

                    mt = gzb.getIntTime(ext);

                    if ((ext > z0) && (ext < z2) && (ext >= 0.0) && (ext < 24.0) && (mt != omt)) {
                        // System.out.println("ext="+String.valueOf(ext));

                        int yp = 130+15*j;
                        int xp;

                        g.drawString("*"+String.valueOf(j)+"."+String.valueOf(mon)+".",10,yp);

                        if (gzb.minima) {
                            if (ext < 12.0)
                                xp = 220;
                            else
                                xp = 300;
                        }
                        else {
                            if (ext < 12.0)
                                xp = 50;
                            else
                                xp = 130;
                        }
                        g.drawString(gzb.getStringTime(start_d+ext/24.0)+"  "+gzb.d2s(gzb.hoehe(start_d+ext/24.0)),xp,yp);
                        omt = mt;
                    }
                }
                z0 = z1;
                z1 = z2;
                h0 = h1;
                h1 = h2;
            }
            start_d += 1;
        }
    }
}

class JahresPlot extends Frame
{
    int aktort, jahr = 2000;

    Berechnung gzb = new Berechnung();

    Label  jahrl;
    TextField jahrf;
    Button ortw, jplus, jminus, end;
    Graph2D gfx;

    public JahresPlot(int ort, int j, int x, int y, int b, int h)
    {
        setLayout(null);
        Font font = new Font("SansSerif",Font.PLAIN,12);
        setFont(font);
        setBackground (Color.lightGray);

        aktort = ort;
        jahr = j;
        gzb.init(aktort);

        setTitle("Jahresgezeitengraph fr "+gzb.getOrt(aktort));

        setBounds (x,y,b,h);

        add (jahrl = new Label("Jahr:"));

        add( jahrf = new TextField("2000"));
        jahrf.addActionListener(new ActionListener() {
	    public void actionPerformed( ActionEvent e) {
	    	repaint();
	    	// textf.getText();
    	    }
        });

        ortw = new Button("Ort");
        add (ortw);
        ortw.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                Message msg = new Message (JahresPlot.this, "Leider noch nicht implementiert");
                repaint();
            }
        });

        add(jplus = new Button("Jahr +"));
        jplus.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (jahr < 2200) jahr++;
                jahrf.setText(String.valueOf(jahr));
                repaint();
            }
        });

        add(jminus = new Button("Jahr -"));
        jminus.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (jahr > 1500) jahr--;
                jahrf.setText(String.valueOf(jahr));
                repaint();
            }
        });

        end = new Button("Ende");
        add (end);
        end.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                dispose();
            }
        });

        addComponentListener(new ComponentListener() {
            public void componentMoved(ComponentEvent e) {}
            public void componentShown(ComponentEvent e) { }
            public void componentHidden(ComponentEvent e) {}

            public void componentResized(ComponentEvent e) {
                Dimension dim = getSize();

                int xd = dim.width-50;
                int yd = dim.height-60;

                jahrl.setBounds(xd-245,yd,30,20);
                jahrf.setBounds(xd-210,yd,40,20);
                jplus.setBounds(xd-160,yd,40,20);
                jminus.setBounds(xd-110,yd,40,20);
                ortw.setBounds(xd-60,yd,40,30);
                end.setBounds(xd-10,yd,40,30);
            }
        });

        show();
    }

    public void paint (Graphics g)
    {
        Dimension dim = getSize();

        int sx = 40, sy = 50;
        int w = dim.width-50, h = dim.height-110;

        gfx = new Graph2D (g, sx, sy, w, h, gzb.maximal, gzb.minimal);

        double start_d = gzb.getDezTime(gzb.getDate(1,1,jahr));   // Dezimalzeit in Tagen seit dem 1.1.1980

        for (int j=1; j<=365; j++)
        {
            double h0, h1, h2, h3, h4, h5;
            double z0, z1, z2, z3, z4, z5;
            double dz, ext, lastext=0;
            int mt, omt=0;
            int omin=0, omax=0;

            if (j%31 == 0) {
                g.setColor(Color.white);
                g.drawLine(40+j,70,40+j,265);
            }

            z0 = -2.0/24.0;
            z1 = -1.5/24.0;

            // System.out.println("start_d="+String.valueOf(start_d));

            h0 = gzb.hoehe (start_d - z0);
            h1 = gzb.hoehe (start_d - z1);

            g.setColor(Color.black);

            for (dz = -1.0; dz <= 26.0; dz += 0.5)
            {
                z2 = dz;
                h2 = gzb.hoehe (start_d + z2/24.0);
                ext = gzb.extr (z0, h0, z1, h1, z2, h2);
                if ((ext > z0) && (ext < z2))
                {
                    z3 = ext - (5.0/60.0);
                    h3 = gzb.hoehe (start_d + z3/24.0);
                    z4 = ext;
                    h4 = gzb.hoehe (start_d + z4/24.0);
                    z5 = ext + (5.0/60.0);
                    h5 = gzb.hoehe (start_d + z5/24.0);
                    ext = gzb.extr (z3, h3, z4, h4, z5, h5);

                    mt = gzb.getIntTime(ext);

                    if ((ext > z0) && (ext < z2) && (ext >= 0.0) && (ext < 24.0) && (mt != omt)) {
                        int hs = gfx.h2y(gzb.hoehe(start_d+ext/24.0));
                        if (gzb.minima) {
                            g.setColor(Color.blue);
                            g.drawLine(40+j,hs,40+j,hs);
                            //omin = hs;
                        }
                        else {
                            g.setColor(Color.red);
                            g.drawLine(40+j,hs,40+j,hs);
                            //omax = hs;
                        }
                        omt = mt;
                    }
                }
                z0 = z1;
                z1 = z2;
                h0 = h1;
                h1 = h2;
            }
            start_d += 1;
        }
    }
}

class Plot extends Frame // implements MouseMotionListener
{
    Berechnung gzb = new Berechnung();
    int aktort;
    Date date;
    DateFormat df = DateFormat.getDateInstance();
    int tage = 1;

    boolean ClearFlag=false;

    int gfx_x, gfx_y, gfx_w, gfx_h;

    double ih=0, iakt=0;
    int ix, iy;

    Button datumb, ortw, zin, zout, prev, next, end;

    public Plot(int ort, Date zeit, int x, int y, int b, int h)
    {
        setLayout(null);
        Font font = new Font("SansSerif",Font.PLAIN,12);
        setFont(font);
        setBackground (Color.lightGray);

        aktort = ort;
        date = zeit;
        gzb.init(aktort);

        setTitle("Gezeitengraph fr "+gzb.getOrt(aktort));

        setBounds (x,y,b,h);

        datumb = new Button("Datum");
        add (datumb);
        datumb.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
        	    StringBuffer sb = new StringBuffer(df.format(date));
                Requester myreq = new Requester (Plot.this, "Bitte neues Datum eingeben",sb);
        	    date = gzb.parseDate(sb.toString());
        	    repaint();
            }
        });
/*
        add (ortw = new Button("Ort"));
        ortw.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                Message msg = new Message (Plot.this, "Leider noch nicht implementiert");
                repaint();
            }
        });
*/
        add (zin = new Button("Zoom +"));
        zin.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (tage > 1) tage /=2;
                repaint();
            }
        });

        zout = new Button("Zoom -");
        add (zout);
        zout.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (tage < 32) tage *= 2;
                repaint();
            }
        });

        prev = new Button("Tag-");
        add (prev);
        prev.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                date.setTime(date.getTime()-60*60*24*1000L);
                repaint();
            }
        });

        next = new Button("Tag+");
        add (next);
        next.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                date.setTime(date.getTime()+60*60*24*1000L);
                repaint();
            }
        });

        end = new Button("Ende");
        add (end);
        end.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                dispose();
            }
        });

        addMouseMotionListener (new MouseMotionListener() {
                public void mouseDragged(MouseEvent e) { }
                public void mouseMoved(MouseEvent e) {
                    Graphics g = getGraphics();
                    int gx    = e.getX();
                    double akt = gzb.getDezTime(date)+((1.0*tage)/(gfx_w-gfx_x))*(gx-gfx_x);
                    double gh = gzb.hoehe(akt);
                    int gy    = h2y(gh);

                    if ((gx > gfx_y) && (gx < gfx_x+gfx_w) && (gy > gfx_y) && (gy < gfx_y+gfx_h)) {
                        g.setColor(Color.lightGray);
                        g.setXORMode(Color.red);

                        if (ClearFlag) {
                            g.drawLine (gfx_x,iy,gfx_x+gfx_w,iy);
                            g.drawLine (ix,gfx_y,ix,gfx_y+gfx_h);
                            g.drawString (Gezeiten.d2s(ih),gfx_x+5,iy-2);
                            g.drawString (gzb.getStringTime(iakt),ix+2,gfx_y+gfx_h);
                        }
                        ix = gx;
                        iy = gy;
                        ih = gh;
                        iakt = akt;

                        g.drawLine (gfx_x,iy,gfx_x+gfx_w,iy);
                        g.drawLine (ix,gfx_y,ix,gfx_y+gfx_h);
                        g.drawString (Gezeiten.d2s(ih),gfx_x+5,iy-2);
                        g.drawString (gzb.getStringTime(iakt),ix+2,gfx_y+gfx_h);
                        ClearFlag = true;
                    }
            }
        });

        addComponentListener(new ComponentListener() {
            public void componentMoved(ComponentEvent e) {}
            public void componentShown(ComponentEvent e) { }
            public void componentHidden(ComponentEvent e) {}

            public void componentResized(ComponentEvent e) {
                Dimension dim = getSize();

                int xd = dim.width-50;
                int yd = dim.height-60;

                //ortw.setBounds(xd-340,yd,40,30);
                datumb.setBounds(xd-290,yd,50,30);
                zin.setBounds(xd-250,yd,70,30);
                zout.setBounds(xd-180,yd,70,30);
                prev.setBounds(xd-110,yd,50,30);
                next.setBounds(xd-60,yd,50,30);
                end.setBounds(xd-10,yd,50,30);
            }
        });
        show();
    }


    public String getShortDate(Date date)
    {
        Calendar c = Calendar.getInstance();
        c.setTime(date);
        int mon = c.get(Calendar.MONTH)+1;

        String str;

        if (mon < 10)
            str = String.valueOf(c.get(Calendar.DAY_OF_MONTH))+".0"+String.valueOf(mon)+".";
        else
            str = String.valueOf(c.get(Calendar.DAY_OF_MONTH))+"."+String.valueOf(mon)+".";
        return str;
    }

    public double xf, yf;
    public int x0, y0;

    private int h2y (double h)
    {
        return (gfx_y + y0 - (int) ((double) h*yf));
    }

    private void initcoord (int x, int y, int width, int height, double max_y, double min_y)
    {
        int i;

        if (max_y < 1.0) max_y = 1.0;

        if (min_y > -0.1) min_y = -0.1;

        xf = width/24.0*tage;;
        yf = height/(max_y-min_y);   // min_y ist zumeist negativ
        y0 = (int) ((double) (max_y*yf));
        x0 = 0;

        gfx_x = x;
        gfx_y = y;
        gfx_w = width;
        gfx_h = height;

        Graphics g = getGraphics();

        // Beschriftung und Einteilung der x-Achse

        Date dt = new Date(date.getTime());

        g.setColor(Color.white);
        for (i=0; i<13; i++) {
            g.drawLine(x+((width-x+3)*i)/12, y, x+((width-x+3)*i)/12, y+height);

            g.setColor(Color.black);
            //g.drawString(String.valueOf((i*tage*2)%24)+":00",x+((width-x+3)*i)/12-15,y+height+15);
            g.setColor(Color.white);
            
            if (((i*tage)%12) == 0) {
                dt.setTime(date.getTime()+60*60*24*1000L*((i*tage)/12));

                String str;
                if (i < 1) {
                    str = df.format(dt);
                }
                else
                    str = getShortDate(dt);
                g.setColor(Color.black);
                g.drawString(str,x+((width-x+3)*i)/12-15,y+height+30);
                g.setColor(Color.white);
            }
        }

        // Beschriftung und Einteilung der y-Achse

        double f;
        for (i=-25; i<25; i++) {
            f = (double) i/2.0;
            if ((f > min_y) && (f < max_y-0.4)) {
                g.drawLine (x-5,h2y(f),x+width,h2y(f));
                g.setColor(Color.black);
                if (i < 0)
                    g.drawString(String.valueOf(f),x-33,h2y(f)+5);
                else
                    g.drawString(String.valueOf(f),x-25,h2y(f)+5);
                g.setColor(Color.white);
            }
        }

        // Zeichnen der Koordinatenachsen

        g.setColor(Color.black);
        g.drawLine (x,y,x,y+height);
        g.drawLine (x,y+y0,x+width,y+y0);
        g.drawLine (x-5,y+5,x,y);
        g.drawLine (x,y,x+5,y+5);
        g.drawLine (x+width-5,y+y0-5,x+width,y+y0);
        g.drawLine (x+width,y+y0, x+width-5,y+y0+5);

        // Beschriftung der Koordinatenachsen

        g.drawString("h/m",x+5,y+20);
        g.drawString("t/h",x+width-20,y+y0+15);
    }

    public void paint(Graphics g)
    {
        Dimension dim = getSize();
        ClearFlag = false;

        gfx_x = 40;
        gfx_y = 50;
        gfx_w = dim.width-50;
        gfx_h = dim.height-150;

        double akt = gzb.getDezTime(date);

        initcoord (gfx_x,gfx_y,gfx_w,gfx_h,gzb.maximal,gzb.minimal);
        int oldy = h2y(gzb.hoehe(akt));

        g.setColor(Color.blue);

        for (int i=0; i<gfx_w; i++) {
            int hs = h2y(gzb.hoehe(akt));
            g.drawLine(i+gfx_x-1,oldy,i+gfx_x, hs);
            oldy = hs;
            akt += (1.0*tage)/(gfx_w-gfx_x);
        }
    }
}

class Graph2D
{
    public double xf, yf;
    public int x0, y0, xoff, yoff;

    public Graph2D (Graphics g, int x, int y, int width, int height, double max_y, double min_y)
    {
        int i;

        if (max_y < 1.0) max_y = 1.0;

        xf = width/12.0;
        yf = height/(max_y-min_y);   // min_y ist zumeist negativ
        y0 = (int) ((double) (max_y*yf));
        x0 = 0;

        xoff = x;
        yoff = y;

        // Graphics g = getGraphics();
        // Beschriftung und Einteilung der x-Achse
        // Date dt = new Date(date.getTime());

        g.setColor(Color.white);

/*
        for (i=0; i<12; i++) {
            g.drawLine(x+(width/12)*i, y, x+(width/12)*i, y+height);
            g.drawString(String.valueOf((i*tage*2)%24)+":00",x+(width/12)*i-15,y+height+15);
            if (((i*tage)%12) == 0) {
                dt.setTime(date.getTime()+60*60*24*1000L*((i*tage)/12));

                String str;
                if (i < 1) {
                    str = df.format(dt);
                }
                else {
                    Calendar c = Calendar.getInstance();
                    c.setTime(dt);
                    int mon = c.get(Calendar.MONTH)+1;

                    if (mon < 10)
                        str = String.valueOf(c.get(Calendar.DAY_OF_MONTH))+".0"+String.valueOf(mon)+".";
                    else
                        str = String.valueOf(c.get(Calendar.DAY_OF_MONTH))+"."+String.valueOf(mon)+".";
                }
                g.drawString(str,x+(width/12)*i-15,y+height+30);
            }
        }
*/
        // Beschriftung und Einteilung der y-Achse

        double f;
        for (i=-25; i<25; i++) {
            f = (double) i/2.0;
            if ((f > min_y) && (f < max_y-0.4))
            {
                g.drawLine (x-5,h2y(f),x+width,h2y(f));
                if (i < 0)
                    g.drawString(String.valueOf(f),x-33,h2y(f)+5);
                else
                    g.drawString(String.valueOf(f),x-25,h2y(f)+5);
            }
        }

        // Zeichnen der Koordinatenachsen

        g.setColor(Color.black);
        g.drawLine (x,y,x,y+height);
        g.drawLine (x,y+y0,x+width,y+y0);
        g.drawLine (x-5,y+5,x,y);
        g.drawLine (x,y,x+5,y+5);
        g.drawLine (x+width-5,y+y0-5,x+width,y+y0);
        g.drawLine (x+width,y+y0, x+width-5,y+y0+5);

        // Beschriftung der Koordinatenachsen

        g.drawString("h/m",x+5,y+20);
        g.drawString("t",x+width-20,y+y0+15);
    }

    public int h2y (double h)
    {
        return (yoff + y0 - (int) ((double) h*yf));
    }
}

class Berechnung
{
    private double ak[][] = {
    // Phasenlage, Phasengewschw. am 1.1.1980
        {  78.16, 13.17639673 },    // Siderischer Monat
        { 279.82,  0.98564734 },    // Sonnenjahr
        { 349.50,  0.11140408 },    // Mondbahnperigum
        { 208.10,  0.05295392 },    // Knotenumlauf
        { 282.60,  0.00047069 },    // Erdbahnperihel
        {  90.00,  0.00000000 }
    };

    private double gp[][] = {
    // j,n1,n2,n3,n4,n5,n6, Fakt, Index
     { 0, 0, 1, 0, 0, 0, 0, 1.0,   1 }, // Sa
     { 1, 0, 1, 0, 0, 0, 1, 1.0,   4 }, // K1
     { 1,-2, 1, 0, 0, 0,-1, 1.0,   3 }, // O1
     { 1,-3, 1, 1, 0, 0,-1, 1.0,   2 }, // Q1
     { 1, 0,-1, 0, 0, 0, 1,-1/3.0, 4 }, // P1
     { 1,-2, 1, 0,-1, 0,-1, 1/5.3, 3 }, // o1
     { 1, 0, 1, 0, 1, 0, 1, 1/7.4, 4 }, // k1
     { 2,-2, 2, 0, 0, 0, 0, 1.0,   6 }, // M2
     { 2,-3, 2, 1, 0, 0, 0, 1.0,   5 }, // N2
     { 2, 0, 0, 0, 0, 0, 0, 1.0,   7 }, // S2
     { 2,-4, 2, 2, 0, 0, 0, 1/7.6, 5 }, // 2N2
     { 2,-4, 4, 0, 0, 0, 0, 1/6.3, 5 }, // m2
     { 2,-3, 4,-1, 0, 0, 0, 1/5.3, 5 }, // v2
     { 2,-1, 2,-1, 0, 0, 0,-1/35., 6 }, // L2
     { 2, 0, 2, 0, 0, 0, 0, 1/3.7, 7 }, // K2
     { 2, 0,-1, 0, 0, 0, 0, 1/17., 7 }, // T2
     { 2,-2, 2, 0,-1, 0, 0,-1/27., 6 }, // m2
     { 2, 0, 2, 0, 1, 0, 0, 1/12., 7 }, // k2
     { 4,-5, 4, 1, 0, 0, 0, 1.0,   8 }, // MN4
     { 4,-4, 4, 0, 0, 0, 0, 1.0,   9 }, // M4
     { 4,-2, 2, 0, 0, 0, 0, 1.0,  10 }  // MS4
    };

    private double amp[] = new double[21];
    private double pha[] = new double[21];;
    private double n0_sum[] = new double[21];
    private double nfi_sum[] = new double[21];
    public  double minimal, maximal, hub, z0;

    public boolean minima;

    private int aktort = -1;

    public GZParm gzp = new GZParm();

    // Sucht in GZParm.ort[] nach Namen und gibt Index zurck

    public int getOrtIndex(String orts)
    {
        int i;

        for (i=0; i < gzp.MAXORT; i++)
            if (orts == gzp.ort[i]) return i;

        return -1;
    }

    // Liefert zum Ortsindex passenden String

    public String getOrt(int index)
    {
        if (index > gzp.MAXORT)
            return ("");

        return gzp.ort[index];
    }

    // Sucht in GZParm.land[] nach Namen und gibt Index zurck

    public int getLandIndex(String lands)
    {
        int i;

        for (i=0; i < gzp.MAXLAND; i++)
            if (lands == gzp.land[i]) return i;

        return -1;
    }

    // Liefert zum Landindex passenden String

    public String getLand(int index)
    {
        if (index > gzp.MAXLAND)
            return ("");

        return gzp.land[index];
    }


    // Liefert zu einem Ortsindex den dazugehrigen Landindex

    public int getLandIdxOrt (int index)
    {
        if (index > gzp.MAXORT) return -1;

        return gzp.lpos[index];
    }

    // Liefert Maximale Anzahl Orte

    public int getMaxOrt()
    {
        return gzp.MAXORT;
    }


    // Liefert Maximale Anzahl Laender

    public int getMaxLand()
    {
        return gzp.MAXLAND;
    }

    // Initialisieren der Gezeitenparameter

    public boolean init(int p)
    {
        int i, j;
        double maxsum;

        if (p > gzp.MAXORT) return false;

        aktort = p;

        for (i=0; i<21; i++) {
            n0_sum[i]  = 0;
            nfi_sum[i] = 0;

            for (j=0; j<6; j++) {
                n0_sum[i]  += gp[i][j+1] * ak[j][0];
                nfi_sum[i] += gp[i][j+1] * ak[j][1];
            }
            amp[i] = gp[i][7] * gzp.amp[p][ (int) gp[i][8]-1 ];
            pha[i] =            gzp.pha[p][ (int) gp[i][8]-1 ];

        }
        pha[16] += 77; // Muss korrigiert werden

        maxsum = 0;
        for (i=0; i<21; i++) maxsum += amp[i];
        maxsum /= 10; // Maxsum in cm umwandeln

        z0 = gzp.z0[p];
        minimal = (z0-maxsum)/100;  // Minimal in m
        maximal = (z0+maxsum)/100;  // Maximal in m
        hub = maximal - minimal;

        return true;
    }

    // h = hoehe(zeit)
    // Berechnet Gezeitenhhe in Abhngigkeit der
    // Amplituden Phasen und Phasengeschwindigeiten der 21 Teilgezeiten
    // zeit: Dezimalzahl, Vorkommastellen sind ganze Tage, Nachkommastellen Bruchteil eines Tages
    // h: Hhe in Meter

    public double hoehe(double zeit)   // zeit: Vorkommastellen tage seit 1.1.80, Nachkommas. bruchteil eines Tages
    {
        double h,t;
        int i;

        if (aktort == -1) return Double.NaN;  // Falls Ort nicht initialisiert

        t = zeit-(double)(int) zeit; // Tagesbruchteil ausrechnen
        h = z0*10.0;                   // z0 in mm umrechnen

        for (i=0; i<21; i++) {
                           // drehung tgl    Phi0 am 1.1.80
            h += amp[i]*Math.cos(((360.0*gp[i][0]*t + n0_sum[i] + nfi_sum[i]*zeit) - pha[i])*Math.PI/180.0);
        }
        return (h/1000);    // Hhe in Meter
    }

    public Date getDate(int day, int mon, int year)
    {
        // return new Date(year - 1900, mon-1, day);
        Calendar c = Calendar.getInstance();
        c.set(year, mon-1, day);

        return c.getTime();
    }


    public Date parseDate(String str)
    {
        Date date = new Date();

        DateFormat df = DateFormat.getDateInstance();

        try {
            date = df.parse(str);
        } catch (ParseException e) { };

        return date;
    }

    public Date getRefDate()
    {
        return getDate(1,1,1980);     // Zeit in Millisekunden seit EPOC (=1.1.1970)
    }

    // Liefert Anzahl Tage, die seit dem Referenz Datum (1.1.80) vergangen sind
    // Nachkommaanteil ist Bruchteil eines Tages

    public double getDezTime(Date date)
    {
        return ((date.getTime()-getRefDate().getTime())/(60*60*24*1000)+1);   // Dezimalzeit in Tagen seit dem 1.1.1980
    }

    public String getStringTime(double dez_time)
    {
        int min = (int) ((dez_time - (double) ((int) dez_time)) * 24*60);
        int std = min/60;
        min %= 60;

        String str;

        if (min < 10)
            str = String.valueOf(std)+":0"+String.valueOf(min);
        else
            str = String.valueOf(std)+":"+String.valueOf(min);

        return (str);
    }

    public int getIntTime(double dez_time)
    {
        return ((int) ((dez_time - (double) ((int) dez_time)) * 24*60));
    }

    public double extr (double x1, double y1, double x2, double y2, double x3, double y3)
    {
        double h1, h2, ax, bx;

        h1 = x3*x3 + x1*x2 + - x1*x3 - x2*x3;
        h2 = x2-x1;

        if ((h1 != 0.0) && (h2 != 0.0)) {
            ax = (y3-y1 + (x1-x3)*(y2-y1)/h2)/h1;
            bx = (y2-y1-ax * (x2*x2 - x1*x1))/h2;
            if (ax != 0) {
                if (ax > 0)
                    minima = true;
                else
                    minima = false;
                return (-bx/(2*ax));
            }
            else
                return -1000;
        }
        else
            return -1000;
    }

    public static String d2s (double d)
    {
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        nf.setMinimumFractionDigits(2);

        String s = nf.format(d);

        return s;
    }
}
