// Ein kleines Applet zum Thema: Berechnen von Gezeiten
// geschrieben 10.08.2000 von Klaus Rotter
// Copyright (C) 2000 by Klaus Rotter (klaus@rotters.de)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License 2 as published by
// the Free Software Foundation

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// History:
// 2000-08-10: Initial Version
// 2003-02-03: Adapted for Sharp-Zaurus 
// 2004-05-30: Removed some Bugs: Zaurus' JRE is a 1.1 machine

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.text.*;
import java.io.*;

public class Gezeiten extends Applet
{
    final int oip = 75;
    final int gip = 120;

    Date date;
    DateFormat df = DateFormat.getDateInstance();

    int tage = 1;
    boolean ClearFlag=false;
    int gfx_x, gfx_y, gfx_w, gfx_h;
    double ih=0, iakt=0;
    int ix, iy;

    int aktort;
    int aktland;
    boolean minima;

    Choice landfeld, ortfeld;
    TextField datumsfeld, zeitfeld;
    Font font;

    Berechnung gzb = new Berechnung();

    public void init()
    {
        // Font initialisieren

        font = new Font("Helvetica",Font.PLAIN,11);
        setFont(font);

        setLayout(null);

        setBackground (Color.lightGray);

        // Buttons und Labels zeichnen

        Label landl = new Label("Land:");
        add(landl);
        landl.setBounds (2,28,30,10);

        landfeld = new Choice();
        add(landfeld);
        landfeld.setBounds (32,24,140,20);
        landfeld.addItemListener (new ItemListener() {
            public void itemStateChanged (ItemEvent evt) {
                setaktland(landfeld.getSelectedIndex()+1);
                repaint();
            }
        });

        landfeld.setFont(font);

        Label ortl = new Label("Ort:");
        add (ortl);
        ortl.setBounds (2,48,30,10);

        ortfeld = new Choice();
        add (ortfeld);
        ortfeld.setBounds (32,44,140,20);
        ortfeld.addItemListener (new ItemListener() {
            public void itemStateChanged (ItemEvent evt) {
                ItemSelectable s = evt.getItemSelectable();
                Object[] selected = s.getSelectedObjects();
                if (selected != null)
                    aktort = gzb.getOrtIndex((String) selected[0]);
                gzb.init(aktort);
                repaint();
            }
        });

        Label datuml = new Label("Datum:");
        add (datuml);
        datuml.setBounds (174,28,42,10);
        Date myDate = new Date();
        String dateStr = DateFormat.getDateInstance().format(myDate);
        datumsfeld = new TextField(dateStr);
        add (datumsfeld);
    	datumsfeld.setBounds (175, 44,60,21);
        datumsfeld.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                repaint();
            }
        });

        int bp = 290;
        
        Button zin = new Button("Z+");
        add (zin);
        zin.setBounds(215,180,20,20);
        zin.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (tage > 1) tage /=2;
                repaint();
            }
        });

        Button zout = new Button("Z-");
        add (zout);
        zout.setBounds(215,205,20,20);
        zout.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                if (tage < 32) tage *= 2;
                repaint();
            }
        });

        Button prev = new Button("T-");
        add (prev);
        prev.setBounds(215,230,20,20);
        prev.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                date.setTime(date.getTime()-60*60*24*1000L);
                datumsfeld.setText(df.format(date));
                repaint();
            }
        });

        Button next = new Button("T+");
        add (next);
        next.setBounds(215,255,20,20);
        next.addActionListener(new ActionListener() {
            public void actionPerformed( ActionEvent e) {
                date.setTime(date.getTime()+60*60*24*1000L);
                datumsfeld.setText(df.format(date));
                repaint();
            }
        });

        for (int i=1; i < gzb.getMaxLand(); i++) {
            // System.out.println("i="+String.valueOf(i)+" land:"+gzb.getLand(i));
            landfeld.add (gzb.getLand(i));
        }
        setaktland(8);
        landfeld.select(7);
        aktort = 10;        // Bsum
        gzb.init(aktort);
        repaint();	
    } // end of init()

    public void setaktland (int pos)
    {
        int i, a=2^30;

        ortfeld.removeAll();

        for (i=0; i < gzb.getMaxOrt(); i++) {
            if (gzb.getLandIdxOrt(i) == pos) {
                ortfeld.add(gzb.getOrt(i));
            }
        }
        aktort = gzb.getOrtIndex(ortfeld.getSelectedItem());
        gzb.init(aktort);
    }

    // text3d (String str, x, y, size)
    // Gibt Text str schattiert an Position x,y mit Grsse size aus

    public void text3d(String txt, int x, int y, int size)
    {
        Font old, fnt = new Font("Helvetica",Font.PLAIN, size);

        Graphics g = getGraphics();
        old = g.getFont();
        g.setFont(fnt);

        g.setColor(Color.black);
        g.drawString(txt,x,y);
        g.setFont(old);
    }

    public void drawCenterString(String txt, int y, int size, Color color)
    {
        Font old, fnt = new Font("Helvetica",Font.PLAIN, size);

        Graphics g = getGraphics();
        old = g.getFont();
        g.setFont(fnt);
        
        Color oldcol = g.getColor();
        g.setColor(color);

        int w = g.getFontMetrics().stringWidth(txt);
        g.drawString(txt, (getSize().width-w)/2,y);
        g.setFont(old);
        g.setColor(oldcol);
    }


    private void drawBox(String txt, int x, int y, int width, int height)
    {
        Graphics g = getGraphics();
        int w = g.getFontMetrics().stringWidth(txt);

        g.draw3DRect(x, y, width, height, false);
        g.clearRect(x+2,y-1,w+4,3);
        g.drawString(txt, x+4, y+4);
    }

    public static String d2s (double d)
    {
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        nf.setMinimumFractionDigits(2);
        
        String s = nf.format(d);

        return s;
    }

    public void berechne()
    {
        int i, j;
        int tag, mon, jahr;

        Date akt, z;
        DateFormat df = DateFormat.getDateInstance();
        DateFormat tf = DateFormat.getTimeInstance();

        double start_d, akt_d, h;

        Graphics g = getGraphics();

        //g.clearRect(10,160,520,400);

        drawBox("Ortsinfo", 2, oip-4, 230, 40);
        g.drawString("Position:",7, oip + 12);
        g.drawString("Ortszeit:",120, oip + 12);

        g.setColor(Color.blue);
        //g.drawString(gzb.getOrt(aktort)+" ("+gzb.getLand(gzb.getLandIdxOrt(aktort))+")",50, oip);

        String pos = String.valueOf(gzb.gzp.hmin[aktort])+"."+String.valueOf(gzb.gzp.hsek[aktort])+gzb.gzp.hb[aktort]+" "+String.valueOf(gzb.gzp.vmin[aktort])+"."+String.valueOf(gzb.gzp.vsek[aktort])+gzb.gzp.vl[aktort];
        g.drawString(pos,52, oip + 12);

        if (gzb.gzp.zv[aktort] > 0) 
            g.drawString("+"+String.valueOf(gzb.gzp.zv[aktort])+" (GMT)",165, oip + 12);
        else
            g.drawString(String.valueOf(gzb.gzp.zv[aktort])+" (GMT)",165, oip + 12);
       
        double r = (gzb.gzp.amp[aktort][2] + gzb.gzp.amp[aktort][3])/(gzb.gzp.amp[aktort][6]+gzb.gzp.amp[aktort][5]);

        if (r < 0.25) {
            g.drawString("Halbtgige Gezeitenform mit jeweils etwa",7, oip + 22);
            g.drawString("gleichen Wasserstnden",7, oip + 33);
        }
        else if (r >= 0.25 && r <1.5) {
            g.drawString("Halbtgige Gezeitenform mit unterschiedlichen",7, oip + 22);
            g.drawString("Wasserstnden",7,oip + 33);
        }
        else if (r >= 1.5 && r < 3.0) {
            g.drawString("Gemischte Gezeitenform mit ein oder zwei",7,oip + 22);
            g.drawString("Gezeiten pro Tag",7,oip + 33);
        }
        else {
            g.drawString("Tgliche Gezeitenform mit einer Gezeit",10,oip + 22);
            g.drawString("pro Tag",10,oip + 33);
        }

        g.setColor(Color.black);
        drawBox("Gezeiteninfo", 2, gip, 230, 55);

        // ref = gzb.getDate(1,1,1980);     // Zeit in Sekunden seit EPOC (=1.1.1970)
        akt = gzb.parseDate(datumsfeld.getText());

        start_d = gzb.getDezTime(akt);   // Dezimalzeit in Tagen seit dem 1.1.1980
        akt_d = start_d;

        //String nez;
        //if (gzb.gzp.zv[aktort] > 0)
        //    nez = new String("GMT +"+String.valueOf(gzb.gzp.zv[aktort]));
        //else
        //    nez = new String("GMT "+String.valueOf(gzb.gzp.zv[aktort]));
        // g.drawString("Gezeiten: Minimal: "+d2s(gzb.minimal)+"m, Mittelwert: "+d2s(gzb.z0/100)+"m, Maximal: "+d2s(gzb.maximal)+"m"+" -> max. theo. Tidenhub: "+d2s(gzb.hub)+"m",10,170);
        //g.drawString("Hhe der Gezeit um "+tf.format(akt)+" Uhr ("+nez+"): "+d2s(gzb.hoehe(akt_d))+"m", 7 , gip + 16);
        //g.drawString("Hhe der Gezeit: "+d2s(gzb.hoehe(akt_d))+"m",5,205);
	
        if (false) {
            g.setColor(Color.blue);
            text3d("Wasserstand fr "+gzb.getOrt(aktort)+" am "+df.format(akt),90,230,15);

            text3d("Stunde:",10,240,12);
            text3d("Hhe/m:",10,260,12);
            text3d("Stunde:",10,285,12);
            text3d("Hhe/m:",10,305,12);

            for (j=0; j<2; j++)
            {
                for (i=0; i<12; i++)
                {
                    h = gzb.hoehe (akt_d);
                    g.drawString(gzb.getStringTime(akt_d),80+35*i,240+45*j);
                    g.drawString(d2s(h),80+35*i,260+45*j);
                    akt_d += 1.0/24.0;
                }
            }
        }

        double h0, h1, h2, h3, h4, h5;
        double z0, z1, z2, z3, z4, z5;
        double dz, ext, lastext=0;
        int mt, omt=0;

        z0 = -2.0/24.0;
        z1 = -1.5/24.0;

        h0 = gzb.hoehe (start_d - z0);
        h1 = gzb.hoehe (start_d - z1);

        i = 0;

        g.setColor(Color.blue);

        for (dz = -1.0; dz <= 26.0; dz += 0.5)
        {
            z2 = dz;
            h2 = gzb.hoehe (start_d + z2/24.0);
            ext = extr (z0, h0, z1, h1, z2, h2);
            if ((ext > z0) && (ext < z2))
            {
                z3 = ext - (5.0/60.0);
                h3 = gzb.hoehe (start_d + z3/24.0);
                z4 = ext;
                h4 = gzb.hoehe (start_d + z4/24.0);
                z5 = ext + (5.0/60.0);
                h5 = gzb.hoehe (start_d + z5/24.0);
                ext = extr (z3, h3, z4, h4, z5, h5);

                mt = gzb.getIntTime(ext);

                if ((ext > z0) && (ext < z2) && (ext >= 0.0) && (ext < 24.0) && (mt != omt)) {
                    if (minima)
                        g.drawString("Niedrigwasser: "+gzb.getStringTime(start_d+ext/24.0)+" Uhr  Hhe: "+d2s(gzb.hoehe(start_d+ext/24.0))+"m", 7, gip+15 +12*i++);
                    else
                        g.drawString("Hochwasser:    "+gzb.getStringTime(start_d+ext/24.0)+" Uhr  Hhe: "+d2s(gzb.hoehe(start_d+ext/24.0))+"m", 7, gip+15 +12*i++);
                    omt = mt;
                }
            }
            z0 = z1;
            z1 = z2;
            h0 = h1;
            h1 = h2;
        }
        return;
    }

    public double extr (double x1, double y1, double x2, double y2, double x3, double y3)
    {
        double h1, h2, ax, bx;

        h1 = x3*x3 + x1*x2 + - x1*x3 - x2*x3;
        h2 = x2-x1;

        if ((h1 != 0.0) && (h2 != 0.0)) {
            ax = (y3-y1 + (x1-x3)*(y2-y1)/h2)/h1;
            bx = (y2-y1-ax * (x2*x2 - x1*x1))/h2;
            if (ax != 0) {
                if (ax > 0)
                    minima = true;
                else
                    minima = false;
                return (-bx/(2*ax));
            }
            else
                return -1000;
        }
        else
            return -1000;
    }


//***************************


//        addMouseMotionListener (new MouseMotionListener() {
//                public void mouseDragged(MouseEvent e) { }
//                public void mouseMoved(MouseEvent e) {
//                    Graphics g = getGraphics();
//                    int gx    = e.getX();
//                    double akt = gzb.getDezTime(date)+((1.0*tage)/(gfx_w-gfx_x))*(gx-gfx_x);
//                    double gh = gzb.hoehe(akt);
//                    int gy    = h2y(gh);
//
//                    if ((gx > gfx_y) && (gx < gfx_x+gfx_w) && (gy > gfx_y) && (gy < gfx_y+gfx_h)) {
//                        g.setColor(Color.lightGray);
//                        g.setXORMode(Color.red);

//                        if (ClearFlag) {
//                            g.drawLine (gfx_x,iy,gfx_x+gfx_w,iy);
//                            g.drawLine (ix,gfx_y,ix,gfx_y+gfx_h);
//                            g.drawString (Gezeiten.d2s(ih),gfx_x+5,iy-2);
//                            g.drawString (gzb.getStringTime(iakt),ix+2,gfx_y+gfx_h);
//                        }
//                        ix = gx;
//                        iy = gy;
//                        ih = gh;
//                        iakt = akt;

//                        g.drawLine (gfx_x,iy,gfx_x+gfx_w,iy);
//                        g.drawLine (ix,gfx_y,ix,gfx_y+gfx_h);
//                        g.drawString (Gezeiten.d2s(ih),gfx_x+5,iy-2);
//                        g.drawString (gzb.getStringTime(iakt),ix+2,gfx_y+gfx_h);
//                        ClearFlag = true;
//                    }
//            }
//        });


    public String getShortDate(Date date)
    {
        Calendar c = Calendar.getInstance();
        c.setTime(date);
        int mon = c.get(Calendar.MONTH)+1;

        String str;

        if (mon < 10)
            str = String.valueOf(c.get(Calendar.DAY_OF_MONTH))+".0"+String.valueOf(mon)+".";
        else
            str = String.valueOf(c.get(Calendar.DAY_OF_MONTH))+"."+String.valueOf(mon)+".";
        return str;
    }

    public double xf, yf;
    public int x0, y0;

    private int h2y (double h)
    {
        return (gfx_y + y0 - (int) ((double) h*yf));
    }

    private void initcoord (int x, int y, int width, int height, double max_y, double min_y)
    {
        int i;

        if (max_y < 1.0) max_y = 1.0;

        if (min_y > -0.1) min_y = -0.1;

        xf = width/24.0*tage;;
        yf = height/(Math.abs(max_y)+Math.abs(min_y));   // min_y ist zumeist negativ
        y0 = (int) ((double) (max_y*yf));
        x0 = 0;

        gfx_x = x;
        gfx_y = y;
        gfx_w = width;
        gfx_h = height;

        Graphics g = getGraphics();

        // Beschriftung und Einteilung der x-Achse

        Date dt = new Date(date.getTime());

        g.setColor(Color.white);
        for (i=0; i<13; i++) {
            g.drawLine(x+((width-x+3)*i)/12, y+8, x+((width-x+3)*i)/12, y+height);
            g.setColor(Color.black);
            //g.drawString(String.valueOf((i*tage*2)%24)+":00",x+((width-x+3)*i)/12-15,y+height+15);
            g.setColor(Color.white);
            
            if (((i*tage)%12) == 0) {
                dt.setTime(date.getTime()+60*60*24*1000L*((i*tage)/12));

                g.setColor(Color.black);

                String str;

//                if (i < 1) {
//                    str = df.format(dt);
//                    g.drawString(str,x+((width-x+3)*i)/12-25,y+height+15);
//                }
//                else {
                    str = getShortDate(dt);
                    g.drawString(str,x+((width-x+3)*i)/12-15,y+height+12);
//                }
                g.setColor(Color.white);
            }
        }

        // Beschriftung und Einteilung der y-Achse

        double f;
        for (i=-25; i<25; i++) 
        {
            if (yf > 30)
                f = (double) i/2.0;
            else if (yf > 20)
                f = (double) i/1.0;
            else 
                f = (double) i/0.5;

            if ((f > min_y) && (f < max_y-0.4)) {
                g.drawLine (x-5,h2y(f),x+width,h2y(f));
                g.setColor(Color.black);
                if (i < 0)
                    g.drawString(String.valueOf(f),x-33,h2y(f)+5);
                else
                    g.drawString(String.valueOf(f),x-25,h2y(f)+5);
                g.setColor(Color.white);
            }
        }


        // Zeichnen der Koordinatenachsen

        g.setColor(Color.black);
        g.drawLine (x,y,x,y+height);
        g.drawLine (x,y+y0,x+width,y+y0);
        g.drawLine (x-5,y+5,x,y);
        g.drawLine (x,y,x+5,y+5);
        g.drawLine (x+width-5,y+y0-5,x+width,y+y0);
        g.drawLine (x+width,y+y0, x+width-5,y+y0+5);

        // Beschriftung der Koordinatenachsen

        g.drawString("h/m",x+7,y+10);
        g.drawString("t",x+width+2,y+y0+4);
    }

    public void drawGraph()
    {
        Graphics g = getGraphics();

        // Dimension dim = getSize();
        ClearFlag = false;

        gfx_x = 25;
        gfx_y = 180;
        gfx_w = 180;    //dim.width-50;
        gfx_h = 90;     //dim.height-150;

        date = gzb.parseDate(datumsfeld.getText());
        double akt = gzb.getDezTime(date);

        initcoord (gfx_x,gfx_y,gfx_w,gfx_h,gzb.maximal,gzb.minimal);
        int oldy = h2y(gzb.hoehe(akt));

        g.setColor(Color.blue);

        for (int i=0; i<gfx_w; i++) {
            int hs = h2y(gzb.hoehe(akt));
            g.drawLine(i+gfx_x-1,oldy,i+gfx_x, hs);
            oldy = hs;
            akt += (1.0*tage)/(gfx_w-gfx_x);
        }
    }

//***************************

    public void paint(Graphics g)
    {
        //drawCenterString("Gezeitenberechnung",10,15,Color.black);
        drawCenterString("Gezeiten (c) 2004 Klaus Rotter (kr@rotters.de)",9,10,Color.black);
        drawCenterString("Daten nicht zur Schiffsnavigation verwendbar!",20,10,Color.red);

        Font fnt = new Font("SansSerif",Font.PLAIN,12);
        g.setFont(fnt);
        berechne();
        drawGraph();
    }
    // end of paint
}
// end of class

class Berechnung
{
    private double ak[][] = {
    // Phasenlage, Phasengewschw. am 1.1.1980
        {  78.16, 13.17639673 },    // Siderischer Monat
        { 279.82,  0.98564734 },    // Sonnenjahr
        { 349.50,  0.11140408 },    // Mondbahnperigum
        { 208.10,  0.05295392 },    // Knotenumlauf
        { 282.60,  0.00047069 },    // Erdbahnperihel
        {  90.00,  0.00000000 }
    };

    private double gp[][] = {
    // j,n1,n2,n3,n4,n5,n6, Fakt, Index
     { 0, 0, 1, 0, 0, 0, 0, 1.0,   1 }, // Sa
     { 1, 0, 1, 0, 0, 0, 1, 1.0,   4 }, // K1
     { 1,-2, 1, 0, 0, 0,-1, 1.0,   3 }, // O1
     { 1,-3, 1, 1, 0, 0,-1, 1.0,   2 }, // Q1
     { 1, 0,-1, 0, 0, 0, 1,-1/3.0, 4 }, // P1
     { 1,-2, 1, 0,-1, 0,-1, 1/5.3, 3 }, // o1
     { 1, 0, 1, 0, 1, 0, 1, 1/7.4, 4 }, // k1
     { 2,-2, 2, 0, 0, 0, 0, 1.0,   6 }, // M2
     { 2,-3, 2, 1, 0, 0, 0, 1.0,   5 }, // N2
     { 2, 0, 0, 0, 0, 0, 0, 1.0,   7 }, // S2
     { 2,-4, 2, 2, 0, 0, 0, 1/7.6, 5 }, // 2N2
     { 2,-4, 4, 0, 0, 0, 0, 1/6.3, 5 }, // m2
     { 2,-3, 4,-1, 0, 0, 0, 1/5.3, 5 }, // v2
     { 2,-1, 2,-1, 0, 0, 0,-1/35., 6 }, // L2
     { 2, 0, 2, 0, 0, 0, 0, 1/3.7, 7 }, // K2
     { 2, 0,-1, 0, 0, 0, 0, 1/17., 7 }, // T2
     { 2,-2, 2, 0,-1, 0, 0,-1/27., 6 }, // m2
     { 2, 0, 2, 0, 1, 0, 0, 1/12., 7 }, // k2
     { 4,-5, 4, 1, 0, 0, 0, 1.0,   8 }, // MN4
     { 4,-4, 4, 0, 0, 0, 0, 1.0,   9 }, // M4
     { 4,-2, 2, 0, 0, 0, 0, 1.0,  10 }  // MS4
    };

    private double amp[] = new double[21];
    private double pha[] = new double[21];;
    private double n0_sum[] = new double[21];
    private double nfi_sum[] = new double[21];
    public  double minimal, maximal, hub, z0;

    public boolean minima;

    private int aktort = -1;

    public GZParm gzp = new GZParm();

    // Sucht in GZParm.ort[] nach Namen und gibt Index zurck

    public int getOrtIndex(String orts)
    {
        int i;

        for (i=0; i < gzp.MAXORT; i++)
            if (orts == gzp.ort[i]) return i;

        return -1;
    }

    // Liefert zum Ortsindex passenden String

    public String getOrt(int index)
    {
        if (index > gzp.MAXORT)
            return ("");

        return gzp.ort[index];
    }

    // Sucht in GZParm.land[] nach Namen und gibt Index zurck

    public int getLandIndex(String lands)
    {
        int i;

        for (i=0; i < gzp.MAXLAND; i++)
            if (lands == gzp.land[i]) return i;

        return -1;
    }

    // Liefert zum Landindex passenden String

    public String getLand(int index)
    {
        if (index > gzp.MAXLAND)
            return ("");

        return gzp.land[index];
    }


    // Liefert zu einem Ortsindex den dazugehrigen Landindex

    public int getLandIdxOrt (int index)
    {
        if (index > gzp.MAXORT) return -1;

        return gzp.lpos[index];
    }

    // Liefert Maximale Anzahl Orte

    public int getMaxOrt()
    {
        return gzp.MAXORT;
    }


    // Liefert Maximale Anzahl Laender

    public int getMaxLand()
    {
        return gzp.MAXLAND;
    }

    // Initialisieren der Gezeitenparameter

    public boolean init(int p)
    {
        int i, j;
        double maxsum;

        if (p > gzp.MAXORT) return false;

        aktort = p;

        for (i=0; i<21; i++) {
            n0_sum[i]  = 0;
            nfi_sum[i] = 0;

            for (j=0; j<6; j++) {
                n0_sum[i]  += gp[i][j+1] * ak[j][0];
                nfi_sum[i] += gp[i][j+1] * ak[j][1];
            }
            amp[i] = gp[i][7] * gzp.amp[p][ (int) gp[i][8]-1 ];
            pha[i] =            gzp.pha[p][ (int) gp[i][8]-1 ];

        }
        pha[16] += 77; // Muss korrigiert werden

        maxsum = 0;
        for (i=0; i<21; i++) maxsum += amp[i];
        maxsum /= 10; // Maxsum in cm umwandeln

        z0 = gzp.z0[p];
        minimal = (z0-maxsum)/100;  // Minimal in m
        maximal = (z0+maxsum)/100;  // Maximal in m
        hub = maximal - minimal;

        return true;
    }

    // h = hoehe(zeit)
    // Berechnet Gezeitenhhe in Abhngigkeit der
    // Amplituden Phasen und Phasengeschwindigeiten der 21 Teilgezeiten
    // zeit: Dezimalzahl, Vorkommastellen sind ganze Tage, Nachkommastellen Bruchteil eines Tages
    // h: Hhe in Meter

    public double hoehe(double zeit)   // zeit: Vorkommastellen tage seit 1.1.80, Nachkommas. bruchteil eines Tages
    {
        double h,t;
        int i;

        if (aktort == -1) return Double.NaN;  // Falls Ort nicht initialisiert

        t = zeit-(double)(int) zeit; // Tagesbruchteil ausrechnen
        h = z0*10.0;                   // z0 in mm umrechnen

        for (i=0; i<21; i++) {
                           // drehung tgl    Phi0 am 1.1.80
            h += amp[i]*Math.cos(((360.0*gp[i][0]*t + n0_sum[i] + nfi_sum[i]*zeit) - pha[i])*Math.PI/180.0);
        }
        return (h/1000);    // Hhe in Meter
    }

    public Date getDate(int day, int mon, int year)
    {
        // return new Date(year - 1900, mon-1, day);
        Calendar c = Calendar.getInstance();
        c.set(year, mon-1, day);

        return c.getTime();
    }


    public Date parseDate(String str)
    {
        Date date = new Date();

        DateFormat df = DateFormat.getDateInstance();

        try {
            date = df.parse(str);
        } catch (ParseException e) { };

        return date;
    }

    public Date getRefDate()
    {
        return getDate(1,1,1980);     // Zeit in Millisekunden seit EPOC (=1.1.1970)
    }

    // Liefert Anzahl Tage, die seit dem Referenz Datum (1.1.80) vergangen sind
    // Nachkommaanteil ist Bruchteil eines Tages

    public double getDezTime(Date date)
    {
        return ((date.getTime()-getRefDate().getTime())/(60*60*24*1000)+1);   // Dezimalzeit in Tagen seit dem 1.1.1980
    }

    public String getStringTime(double dez_time)
    {
        int min = (int) ((dez_time - (double) ((int) dez_time)) * 24*60);
        int std = min/60;
        min %= 60;

        String str;

        if (min < 10)
            str = String.valueOf(std)+":0"+String.valueOf(min);
        else
            str = String.valueOf(std)+":"+String.valueOf(min);

        return (str);
    }

    public int getIntTime(double dez_time)
    {
        return ((int) ((dez_time - (double) ((int) dez_time)) * 24*60));
    }

    public double extr (double x1, double y1, double x2, double y2, double x3, double y3)
    {
        double h1, h2, ax, bx;

        h1 = x3*x3 + x1*x2 + - x1*x3 - x2*x3;
        h2 = x2-x1;

        if ((h1 != 0.0) && (h2 != 0.0)) {
            ax = (y3-y1 + (x1-x3)*(y2-y1)/h2)/h1;
            bx = (y2-y1-ax * (x2*x2 - x1*x1))/h2;
            if (ax != 0) {
                if (ax > 0)
                    minima = true;
                else
                    minima = false;
                return (-bx/(2*ax));
            }
            else
                return -1000;
        }
        else
            return -1000;
    }

    public static String d2s (double d)
    {
        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(2);
        nf.setMinimumFractionDigits(2);

        String s = nf.format(d);

        return s;
    }
}
