#!/usr/bin/perl

#    $tmp =~ s/[\r\n]//g;                  # Alle NewLine und Carriage Return entfernen
#    $tmp =~ s/^ //g;                      # SPACE am Stringanfang entfernen
#    $tmp =~ s/ $//g;                      # SPACE am Stringende entfernen
#    open (FS, $_[0]);
#    open (FD, ">".$_[1]);
#    printf("Source %s, Dest %s,\n",$_[0],$_[1]);
#    printf FD (" * Automatisch erstellt mit cad2gnu.pl aus der Datei '%s'\n",$_[0]);

#if ($ARGV[0] eq "") {
#    printf("Usage: cad2gnu.pl datei.h ...\n");
#    exit;
#}

sub strip ($)
{
    $tmp = $_[0];

    $tmp =~ s/[\r\n]//g;    # Alle NewLine und Carriage Return entfernen
    $tmp =~ s/^\s+//g;      # SPACE am Stringanfang entfernen
    $tmp =~ s/\s+$//g;      # SPACE am Stringende entfernen
    $tmp =~ s/\s+/ /g;      # Alle SPACES durch max 1 SPACE ersetzten
    $tmp =~ s/\*//g;        # Alle * entfernen
    return ucfirst(lc($tmp));
}

sub dropln ($)
{
    $tmp = $_[0];

    #printf ("Vorher: %s ",$tmp);	

    $tmp =~ s/^[0]+//g;
    
    if ($tmp eq "") { $tmp = "0" };

    #printf ("nachher: %s \n",$tmp);	

    return $tmp;	
}

sub dp ($) # Drop leading plus
{
    $tmp = $_[0];

    #printf ("Vorher: %s ",$tmp);	

    $tmp =~ s/^[+]+//g;
    
    #printf ("nachher: %s \n",$tmp);	

    return $tmp;	
}


open (FG,"gezeiten-parameter") or die "Kann Datei 'gezeiten' nicht finden.\n";

$i=0;
$li = 0;

printf("// Automatically created by gz2java.pl\n\n");
printf("public final class GZParm\n{\n");

while ($buf = readline (*FG))
{
    # $buf =~ /^[\w_]+/;  # Lndernamen extrahieren (erstes Wort am Zeilenanfang

    $sub = substr ($buf, 0, 29);
    $sub = strip $sub;

    if ($land[$li] eq $sub) {
        $lpos[$i] = $li;
    }
    else {
        $li++;
        $land[$li] = $sub;
        $lpos[$i] = $li;
    }
    # printf("\tland[%d] = new String(\"%s\");\n",$i,$&);

    #$' =~ /\s*[\w_]+/;        # Ortnamen extrahieren
    $sub = substr ($buf, 30, 29);
    $ort[$i] = strip($sub);
    # printf("\tort[%d] = new String(\"%s\");\n",$i,strip($&));

    $sub= substr ($buf, 60, 3);
    #printf("\thmin[%d] = %s;\n",$i,$sub);
    $hmin[$i] = dropln($sub);

    $sub= substr ($buf, 64, 2);
    #printf("\thsek[%d] = %s;\n",$i,$sub);
    $hsek[$i] = dropln($sub);

    $sub= substr ($buf, 66, 1);
    #printf("\thbreite[%d] = %s;\n",$i,$sub);
    $hb[$i] = $sub;

    $sub= substr ($buf, 70, 2);
    #printf("\tvmin[%d] = %s;\n",$i,$sub);
    $vmin[$i] = dropln($sub);
    
    $sub= substr ($buf, 73, 2);
    #printf("\tvsek[%d] = %s;\n",$i,$sub);
    $vsek[$i] = dropln($sub);

    $sub= substr ($buf, 75, 1);
    #printf("\tvlaenge[%d] = %s;\n",$i,$sub);
    $vl[$i] = $sub;

    $buf = readline (*FG);

    $sub= substr ($buf, 0, 9);
    #printf("\trefwert[%d] = %s;\n",$i,strip($sub));
    $refwert[$i] = strip($sub);
    
    $sub= substr ($buf, 11, 5);
    #printf("\tzv[%d] = %s;\n",$i,strip($sub));
    $zv[$i] = dp(strip($sub));

    $buf = readline (*FG);
    $buf =~ /^\s+\w+/;
    $z0[$i] = strip($&);
    #printf("\tz0[%d] = %s;\n",$i,strip($&));

    $' =~ /,/;
    $amp[$i] = strip($');
    #printf("\tamp[%d][10] = new double[]{ %s };\n",$i,strip($'));
    $buf = readline (*FG);
    $pha[$i] = strip($buf);
    #printf("\tpha[%d][10] = { %s };\n\n",$i,strip($buf));

    $buf = readline (*FG);
    $i++;
}
$maxi = $i;
$maxli = $li;

printf("\tpublic final int MAXLAND = %d;\n\n",$maxli);

printf("\tpublic final int MAXORT = %d;\n\n",$maxi);

printf("\tString land[] = {\n");
for ($i=0; $i<$maxli; $i++) {
    printf("\t\t\"%s\",\n",$land[$i]);
}
printf("\t\t\"\" };\n\n");

printf("\tint lpos[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t %s ,\n",$lpos[$i]);
}
printf("\t\t 0 };\n\n");

printf("\tString ort[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t\"%s\",\n",$ort[$i]);
}
printf("\t\t\"\" };\n\n");

printf("\tshort z0[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t %s,\n",$z0[$i]);
}
printf("\t\t-1 };\n\n");

printf("\tdouble amp[][] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t{ %s },\n",$amp[$i]);
}
printf("\t\t{ } };\n\n");

printf("\tdouble pha[][] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t{ %s },\n",$pha[$i]);
}
printf("\t\t{ } };\n\n");

printf("\tshort hmin[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t%s,\n",$hmin[$i]);
}
printf("\t\t0 };\n\n");

printf("\tshort hsek[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t%s,\n",$hsek[$i]);
}
printf("\t\t 0 };\n\n");

printf("\tchar hb[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t\'%s\',\n",$hb[$i]);
}
printf("\t\t' ' };\n\n");

printf("\tshort vmin[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t%s,\n",$vmin[$i]);
}
printf("\t\t0 };\n\n");

printf("\tshort vsek[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t%s,\n",$vsek[$i]);
}
printf("\t\t0 };\n\n");

printf("\tchar vl[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t\'%s\',\n",$vl[$i]);
}
printf("\t\t' ' };\n\n");

printf("\tdouble refwert[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t%s,\n",$refwert[$i]);
}
printf("\t\t0 };\n\n");

printf("\tdouble zv[] = {\n");
for ($i=0; $i<$maxi; $i++) {
    printf("\t\t%s,\n",$zv[$i]);
}
printf("\t\t0 };\n\n");


printf("};\n");
